//+------------------------------------------------------------------+
//|                                                   SKYFXSYSTEM.mq4 |
//|                             copyright  2012, SKYFXSYSTEM |
//|                                         http:/SKYFXSYSTEM.COM |
//|                                      INFO@SKYFXSYSTEM.COM |
//+------------------------------------------------------------------+
#property copyright "Copyright  2012, SKYFXSYTEM"
#property link      "http:/SKYFXSYSTEM.COM"


//---- indicator settings
#property indicator_chart_window
#property  indicator_buffers      4
#property  indicator_color1       YellowGreen
#property  indicator_color2       OrangeRed
#property  indicator_color3       YellowGreen
#property  indicator_color4       OrangeRed
#property  indicator_width1       1
#property  indicator_width2       1
#property  indicator_width3       1
#property  indicator_width4       1


//---- indicator parameters
extern string     __Copyright__               = "http://SKYFXSYSTEM.COM";
extern int        AtrPeriod                   = 8;
extern bool       Show_TP_SL                  = true;
extern bool       Show_Levels                 = true;
extern color      BuyColor                    = YellowGreen;
extern color      SellColor                   = OrangeRed;
extern color      FontColor                   = Yellow ;
extern int        DisplayDecimals             = 4;
extern int        PosX                        = 25;
extern int        PosY                        = 25;
extern bool       SoundAlert                  = false;


//---- indicator buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];


double Atr;


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
   IndicatorBuffers(4);
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,233);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,234);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexArrow(2,167);//119
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexArrow(3,167);//119
   SetIndexBuffer(3,ExtMapBuffer4);
  
      
   SetIndexLabel(0,"BUY");
   SetIndexLabel(1,"SELL");
   SetIndexLabel(2,"TakeProfit");
   SetIndexLabel(3,"StopLoss");
   
      
//---- 
   IndicatorShortName("SKYFXSYSTEM");
   
   
   ObjectCreate("SKYFXSYSTEMIndName",OBJ_LABEL,0,0,0,0,0);
   ObjectSet("SKYFXSYSTEMIndName",OBJPROP_CORNER,0);
   ObjectSet("SKYFXSYSTEMIndName",OBJPROP_XDISTANCE,PosX+20);
   ObjectSet("SKYFXSYSTEMIndName",OBJPROP_YDISTANCE,PosY);
   ObjectSetText("SKYFXSYSTEMIndName","SKYFXSYSTEM",8,"Lucida Sans Unicode",FontColor);
   
   ObjectCreate("SKYFXSYSTEMLine0",OBJ_LABEL,0,0,0,0,0);
   ObjectSet("SKYFXSYSTEMLine0",OBJPROP_CORNER,0);
   ObjectSet("SKYFXSYSTEM0",OBJPROP_XDISTANCE,PosX+5);
   ObjectSet("SKYFXSYSTEMLine0",OBJPROP_YDISTANCE,PosY+8);
   ObjectSetText("SKYFXSYSTEMLine0","------------------",8,"Tahoma",FontColor);
   
   ObjectCreate("SKYFXSYSTEMLine1",OBJ_LABEL,0,0,0,0,0);
   ObjectSet("SKYFXSYSTEMLine1",OBJPROP_CORNER,0);
   ObjectSet("SKYFXSYSTEMLine1",OBJPROP_XDISTANCE,PosX+5);
   ObjectSet("SKYFXSYSTEMLine1",OBJPROP_YDISTANCE,PosY+10);
   ObjectSetText("SKYFXSYSTEMLine1","------------------",8,"Tahoma",FontColor);
   
   ObjectCreate("SKYFXSYSTEMDirection",OBJ_LABEL,0,0,0,0,0);
   ObjectSet("SKYFXSYSTEMDirection",OBJPROP_CORNER,0);
   ObjectSet("SKYFXSYSTEMDirection",OBJPROP_XDISTANCE,PosX);
   ObjectSet("SKYFXSYSTEMDirection",OBJPROP_YDISTANCE,PosY+12);
   ObjectSetText("JJNBeeDirection","Wait",20,"Lucida Sans Unicode",FontColor);
      
   ObjectCreate("SKYFXSYSTEMLevel",OBJ_LABEL,0,0,0,0,0);
   ObjectSet("SKYFXSYSTEMLevel",OBJPROP_CORNER,0);
   ObjectSet("SKYFXSYSTEMLevel",OBJPROP_XDISTANCE,PosX);
   ObjectSet("SKYFXSYSTEMLevel",OBJPROP_YDISTANCE,PosY+50);
   ObjectSetText("SKYFXSYSTEMLevel","",9,"Lucida Sans Unicode",FontColor);
   
   
//---- initialization done
   return(0);
  }

int deinit()
  {
//----
  
   ObjectDelete("SKYFXSYSTEMLine0");
   ObjectDelete("SKYFXSYSTEMLine1");
   ObjectDelete("SKYFXSYSTEMIndName");
   ObjectDelete("SKYFXSYSTEMDirection");
   ObjectDelete("SKYFXSYSTEMLevel");   
   
   ObjectDelete("SKYFXSYSTEMEntryLevel");  
   ObjectDelete("SKYFXSYSTEMTPLevel");
   ObjectDelete("SKYFXSYSTEMSLLevel");     
//----
   return(0);
  }

int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- 

   
   
      
   for(int i=0; i<limit; i++)
   {
   Atr=iATR(NULL,0,AtrPeriod,i);
   
   if(Close[i]>Open[i+1] && Close[i+1]<Open[i+1])
      { 
      ExtMapBuffer1[i]=Low[i];
      ExtMapBuffer2[i]=EMPTY_VALUE;
      if(Show_TP_SL) ExtMapBuffer3[i]=Open[i+1]+Atr;
      if(Show_TP_SL) ExtMapBuffer4[i]=Open[i+1]-Atr;
      }
   else if(Close[i]<Open[i+1] && Close[i+1]>Open[i+1])
      {
      ExtMapBuffer1[i]=EMPTY_VALUE;
      ExtMapBuffer2[i]=High[i];
      if(Show_TP_SL) ExtMapBuffer3[i]=Open[i+1]-Atr;
      if(Show_TP_SL) ExtMapBuffer4[i]=Open[i+1]+Atr;
      }
   else 
      {
      ExtMapBuffer1[i]=EMPTY_VALUE;
      ExtMapBuffer2[i]=EMPTY_VALUE;
      ExtMapBuffer3[i]=EMPTY_VALUE;
      ExtMapBuffer4[i]=EMPTY_VALUE;
      }
   }
  
  
   if(Close[0]>Open[1] && Close[1]<Open[1]) // BUY
      { 
      ObjectDelete("SKYFXSYSTEMEntryLevel");  
      ObjectDelete("SKYFXSYSTEMTPLevel");
      ObjectDelete("SKYFXSYSTEMSLLevel"); 
      
      ObjectSet("SKYFXSYSTEMDirection",OBJPROP_XDISTANCE,PosX+5);
      ObjectSetText("SKYFXSYSTEMDirection","BUY",28,"Lucida Sans Unicode",BuyColor); 
      ObjectSetText("SKYFXSYSTEMLevel","above "+DoubleToStr(Open[1],DisplayDecimals),9,"Lucida Sans Unicode",BuyColor);
      if(Show_Levels)
         {
         ObjectCreate("SKYFXSYSTEMEntryLevel",OBJ_TREND,0,Time[1],Open[1],Time[0],Open[1]);
         ObjectSet("SKYFXSYSTEMEntryLevel",OBJPROP_RAY,True);
         ObjectSet("SKYFXSYSTEMEntryLevel",OBJPROP_BACK,True); // obj in the background
         ObjectSet("SKYFXSYSTEMLevel",OBJPROP_STYLE,STYLE_SOLID);
         ObjectSet("SKYFXSYSTEMEntryLevel",OBJPROP_WIDTH,1);
         ObjectSet("SKYFXSYSTEMEntryLevel",OBJPROP_COLOR,FontColor);
         ObjectCreate("SKYFXSYSTEMTPLevel",OBJ_TREND,0,Time[1],Open[1]+Atr,Time[0],Open[1]+Atr);
         ObjectSet("SKYFXSYSTEMTPLevel",OBJPROP_RAY,True);
         ObjectSet("SKYFXSYSTEMTPLevel",OBJPROP_BACK,True); // obj in the background
         ObjectSet("SKYFXSYSTEMTPLevel",OBJPROP_STYLE,STYLE_SOLID);
         ObjectSet("SKYFXSYSTEMTPLevel",OBJPROP_WIDTH,1);
         ObjectSet("SKYFXSYSTEMTPLevel",OBJPROP_COLOR,BuyColor);
         ObjectCreate("SKYFXSYSTEMSLLevel",OBJ_TREND,0,Time[1],Open[1]-Atr,Time[0],Open[1]-Atr);
         ObjectSet("SKYFXSYSTEMSLLevel",OBJPROP_RAY,True);
         ObjectSet("SKYFXSYSTEMSLLevel",OBJPROP_BACK,True); // obj in the background
         ObjectSet("SKYFXSYSTEMSLLevel",OBJPROP_STYLE,STYLE_SOLID);
         ObjectSet("SKYFXSYSTEMSLLevel",OBJPROP_WIDTH,1);
         ObjectSet("SKYFXSYSTEMSLLevel",OBJPROP_COLOR,SellColor);
         }
      if(SoundAlert) PlaySound("alert.wav");
      }
   else if(Close[0]<Open[1] && Close[1]>Open[1]) // SELL
      {
      ObjectSet("SKYFXSYSTEMDirection",OBJPROP_XDISTANCE,PosX+2);
      ObjectSetText("SKYFXSYSTEMDirection","SELL",28,"Lucida Sans Unicode",SellColor); 
      ObjectSetText("SKYFXSYSTEMLevel","under "+DoubleToStr(Open[1],DisplayDecimals),9,"Lucida Sans Unicode",SellColor); 
      if(Show_Levels)
         {
         ObjectCreate("SKYFXSYSTEMEntryLevel",OBJ_TREND,0,Time[1],Open[1],Time[0],Open[1]);
         ObjectSet("SKYFXSYSTEMEntryLevel",OBJPROP_RAY,True);
         ObjectSet("SKYFXSYSTEMEntryLevel",OBJPROP_BACK,True); // obj in the background
         ObjectSet("SKYFXSYSTEMEntryLevel",OBJPROP_STYLE,STYLE_SOLID);
         ObjectSet("SKYFXSYSTEMEntryLevel",OBJPROP_WIDTH,1);
         ObjectSet("SKYFXSYSTEMEntryLevel",OBJPROP_COLOR,FontColor);
         ObjectCreate("SKYFXSYSTEMTPLevel",OBJ_TREND,0,Time[1],Open[1]-Atr,Time[0],Open[1]-Atr);
         ObjectSet("SKYFXSYSTEMTPLevel",OBJPROP_RAY,True);
         ObjectSet("SKYFXSYSTEMTPLevel",OBJPROP_BACK,True); // obj in the background
         ObjectSet("SKYFXSYSTEMTPLevel",OBJPROP_STYLE,STYLE_SOLID);
         ObjectSet("SKYFXSYSTEMTPLevel",OBJPROP_WIDTH,1);
         ObjectSet("SKYFXSYSTEMTPLevel",OBJPROP_COLOR,BuyColor);
         ObjectCreate("SKYFXSYSTEMSLLevel",OBJ_TREND,0,Time[1],Open[1]+Atr,Time[0],Open[1]+Atr);
         ObjectSet("SKYFXSYSTEMSLLevel",OBJPROP_RAY,True);
         ObjectSet("SKYFXSYSTEMSLLevel",OBJPROP_BACK,True); // obj in the background
         ObjectSet("SKYFXSYSTEMSLLevel",OBJPROP_STYLE,STYLE_SOLID);
         ObjectSet("SKYFXSYSTEMSLLevel",OBJPROP_WIDTH,1);
         ObjectSet("SKYFXSYSTEMSLLevel",OBJPROP_COLOR,SellColor);
         }
      if(SoundAlert) PlaySound("alert.wav");
      }
   else 
      {
      ObjectSet("SKYFXSYSTEMDirection",OBJPROP_XDISTANCE,PosX+8);
      ObjectSetText("SKYFXSYSTEMDirection","WAIT",20,"Lucida Sans Unicode",FontColor); 
      ObjectSetText("SKYFXSYSTEMLevel","",9,"Lucida Sans Unicode",FontColor);
      ObjectDelete("SKYFXSYSTEMEntryLevel");  
      ObjectDelete("SKYFXSYSTEMTPLevel");
      ObjectDelete("SKYFXSYSTEMSLLevel");
      }
  
   //Comment("");
   
         
    
//---- done
   return(0);
  }
//+------------------------------------------------------------------+